diff -urN punbb-1.3/README punbb-1.3.4/README
--- punbb-1.3/README	2008-10-31 09:04:18.000000000 +0000
+++ punbb-1.3.4/README	2009-04-17 12:51:23.000000000 +0000
@@ -30,7 +30,7 @@
  2. Log into the forum and go to "Administration" console, "Extensions" section, choose "Install extensions" tab (e.g. http://example.com/punbb/admin/extensions.php?section=install). The downloaded extension will be listed there.
  3. Click the "Install extension" link to install the extension.
 
-NOTE: You may use the pun_admin_repository official PunBB extension to download and install extensions from PunBB repository with one click.
+NOTE: You may use the pun_repository official PunBB extension to download and install extensions from PunBB repository with one click.
 
 	 Maximizing Performance
 	------------------------
@@ -53,8 +53,8 @@
 
 	 Copyright and disclaimer
 	--------------------------
-This package and its contents are copyright (C) 2002-2008 PunBB, all rights reserved.
-Partially based on code copyright (C) 2008 FluxBB.org.
+This package and its contents are (C) 2002-2009 PunBB, all rights reserved.
+Partially based on code (C) 2008-2009 FluxBB.org.
 
 PunBB is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 
diff -urN punbb-1.3/admin/bans.php punbb-1.3.4/admin/bans.php
--- punbb-1.3/admin/bans.php	2008-11-07 21:10:35.000000000 +0000
+++ punbb-1.3.4/admin/bans.php	2009-04-17 12:51:23.000000000 +0000
@@ -4,7 +4,7 @@
  *
  * Allows administrators and moderators to create, modify, and delete bans.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -134,11 +134,12 @@
 	// Setup breadcrumbs
 	$forum_page['crumbs'] = array(
 		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
-		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
-		array($lang_admin_common['Users'], forum_link($forum_url['admin_users'])),
-		array($lang_admin_common['Bans'], forum_link($forum_url['admin_bans'])),
-		$lang_admin_bans['Ban advanced']
+		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index']))
 	);
+	if ($forum_user['g_id'] == FORUM_ADMIN)
+		$forum_page['crumbs'][] = array($lang_admin_common['Users'], forum_link($forum_url['admin_users']));
+	$forum_page['crumbs'][] = array($lang_admin_common['Bans'], forum_link($forum_url['admin_bans']));
+	$forum_page['crumbs'][] = $lang_admin_bans['Ban advanced'];
 
 	($hook = get_hook('aba_add_edit_ban_pre_header_load')) ? eval($hook) : null;
 
@@ -156,15 +157,17 @@
 		<h2 class="hn"><span><?php echo $lang_admin_bans['Ban advanced heading'] ?></span></h2>
 	</div>
 	<div class="main-content main-frm">
-		<div class="ct-box">
+		<div class="ct-box warn-box">
 			<p class="warn"><?php echo $lang_admin_bans['Ban IP warning'] ?></p>
 		</div>
 		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['admin_bans']) ?>">
 			<div class="hidden">
 				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['admin_bans'])) ?>" />
 				<input type="hidden" name="mode" value="<?php echo $mode ?>" />
-<?php if ($mode == 'edit'): ?>				<input type="hidden" name="ban_id" value="<?php echo $ban_id ?>" />
-<?php endif; ?>			</div>
+<?php if ($mode == 'edit'): ?>
+				<input type="hidden" name="ban_id" value="<?php echo $ban_id ?>" />
+<?php endif; ?>
+			</div>
 <?php ($hook = get_hook('aba_add_edit_ban_pre_criteria_fieldset')) ? eval($hook) : null; ?>
 			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
 				<legend class="group-legend"><span><?php echo $lang_admin_bans['Ban criteria legend'] ?></span></legend>
@@ -390,10 +393,12 @@
 // Setup breadcrumbs
 $forum_page['crumbs'] = array(
 	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
-	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
-	array($lang_admin_common['Users'], forum_link($forum_url['admin_users'])),
-	array($lang_admin_common['Bans'], forum_link($forum_url['admin_bans']))
+	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index']))
 );
+if ($forum_user['g_id'] == FORUM_ADMIN)
+	$forum_page['crumbs'][] = array($lang_admin_common['Users'], forum_link($forum_url['admin_users']));
+$forum_page['crumbs'][] = array($lang_admin_common['Bans'], forum_link($forum_url['admin_bans']));
+
 
 ($hook = get_hook('aba_pre_header_load')) ? eval($hook) : null;
 
@@ -481,10 +486,12 @@
 						<h3 class=""><span><?php printf($lang_admin_bans['Current ban head'], $forum_page['ban_creator']) ?></span></h3>
 						<p><?php printf($lang_admin_bans['Edit or remove'], '<a href="'.forum_link($forum_url['admin_bans']).'?edit_ban='.$cur_ban['id'].'">'.$lang_admin_bans['Edit ban'].'</a>', '<a href="'.forum_link($forum_url['admin_bans']).'?del_ban='.$cur_ban['id'].'&amp;csrf_token='.generate_form_token('del_ban'.$cur_ban['id']).'">'.$lang_admin_bans['Remove ban'].'</a>') ?></p>
 					</div>
-<?php if (!empty($forum_page['ban_info'])): ?>				<ul>
+<?php if (!empty($forum_page['ban_info'])): ?>
+				<ul>
 					<?php echo implode("\n", $forum_page['ban_info'])."\n" ?>
 					</ul>
-<?php endif; ?>				</div>
+<?php endif; ?>
+				</div>
 			</div>
 <?php
 
diff -urN punbb-1.3/admin/categories.php punbb-1.3.4/admin/categories.php
--- punbb-1.3/admin/categories.php	2008-10-30 09:58:26.000000000 +0000
+++ punbb-1.3.4/admin/categories.php	2009-04-17 12:51:23.000000000 +0000
@@ -4,7 +4,7 @@
  *
  * Allows administrators to create, reposition, and remove categories.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -214,7 +214,7 @@
 		if (isset($cat_name[$cur_cat['id']]) && isset($cat_order[$cur_cat['id']]))
 		{
 			if ($cat_name[$cur_cat['id']] == '')
-				message($lang_admin_categories['Must enter category']);
+				message($lang_admin_categories['Must name category']);
 
 			if ($cat_order[$cur_cat['id']] < 0)
 				message($lang_admin_categories['Must be integer']);
diff -urN punbb-1.3/admin/censoring.php punbb-1.3.4/admin/censoring.php
--- punbb-1.3/admin/censoring.php	2008-10-30 22:16:26.000000000 +0000
+++ punbb-1.3.4/admin/censoring.php	2009-04-17 12:51:23.000000000 +0000
@@ -4,7 +4,7 @@
  *
  * Allows administrators and moderators to add, modify, and delete the word censors used by the software when censoring is enabled.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -138,10 +138,12 @@
 // Setup breadcrumbs
 $forum_page['crumbs'] = array(
 	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
-	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
-	array($lang_admin_common['Settings'], forum_link($forum_url['admin_settings_setup'])),
-	array($lang_admin_common['Censoring'], forum_link($forum_url['admin_censoring']))
+	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index']))
 );
+if ($forum_user['g_id'] == FORUM_ADMIN)
+	$forum_page['crumbs'][] = array($lang_admin_common['Settings'], forum_link($forum_url['admin_settings_setup']));
+$forum_page['crumbs'][] = array($lang_admin_common['Censoring'], forum_link($forum_url['admin_censoring']));
+
 
 ($hook = get_hook('acs_pre_header_load')) ? eval($hook) : null;
 
diff -urN punbb-1.3/admin/db_update.php punbb-1.3.4/admin/db_update.php
--- punbb-1.3/admin/db_update.php	2008-11-09 13:35:41.000000000 +0000
+++ punbb-1.3.4/admin/db_update.php	2009-05-20 09:20:51.000000000 +0000
@@ -4,14 +4,14 @@
  *
  * Updates the database to the latest version.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
 
 
-define('UPDATE_TO', '1.3');
-define('UPDATE_TO_DB_REVISION', 3);
+define('UPDATE_TO', '1.3.4');
+define('UPDATE_TO_DB_REVISION', 4);
 
 // The number of items to process per pageview (lower this if the update script times out during UTF-8 conversion)
 define('PER_PAGE', 300);
@@ -39,7 +39,8 @@
 	exit('Cannot find config.php, are you sure it exists?');
 
 // Enable debug mode
-define('FORUM_DEBUG', 1);
+if (!defined('FORUM_DEBUG')) 
+	define('FORUM_DEBUG', 1);
 
 // Turn on full PHP error reporting
 error_reporting(E_ALL);
@@ -284,12 +285,15 @@
 	$seems_utf8 = true;
 
 	$query = array(
-		'SELECT'	=> 'MIN(id), MAX(id)',
+		'SELECT'	=> 'MIN(id), MAX(id), COUNT(id)',
 		'FROM'		=> 'posts'
 	);
 
 	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
-	list($min_id, $max_id) = $forum_db->fetch_row($result);
+	list($min_id, $max_id, $count_id) = $forum_db->fetch_row($result);
+
+	if ($count_id == 0)
+		return false;
 
 	// Get a random soup of data and check if it appears to be UTF-8
 	for ($i = 0; $i < 100; ++$i)
@@ -408,7 +412,7 @@
 <div id="brd-main" class="main basic">
 
 	<div class="main-head">
-		<h1 class="hn"><span>PunBB Database Update : Perform update of database tables</span></h1>
+		<h1 class="hn"><span>PunBB Database Update: Perform update of database tables</span></h1>
 	</div>
 
 	<div class="main-content frm">
@@ -416,7 +420,7 @@
 			<ul class="spaced">
 				<li class="warn"><span><strong>WARNING!</strong> This script will update your PunBB forum database. The update procedure might take anything from a few seconds to a few minutes (or in extreme cases, hours) depending on the speed of the server, the size of the forum database and the number of changes required.</span></li>
 				<li><span>Do not forget to make a backup of the database before continuing.</span></li>
-				<li><span> Did you read the update instructions in the documentation? If not, start there.</span></li>
+				<li><span>Did you read the update instructions in the documentation? If not, start there.</span></li>
 <?php
 
 if (strpos($cur_version, '1.2') === 0 && (!$db_seems_utf8 || isset($_GET['force'])))
@@ -725,7 +729,7 @@
 
 		// Make all IP fields VARCHAR(39) to support IPv6
 		$forum_db->alter_field('posts', 'poster_ip', 'VARCHAR(39)', true);
-		$forum_db->alter_field('user', 'registration_ip', 'VARCHAR(39)', false, '0.0.0.0');
+		$forum_db->alter_field('users', 'registration_ip', 'VARCHAR(39)', false, '0.0.0.0');
 
 		// Add the DST option to the users table
 		$forum_db->add_field('users', 'dst', 'TINYINT(1)', false, 0, 'timezone');
@@ -1222,7 +1226,7 @@
 		$forum_db->set_names('utf8');
 
 		// Convert config
-		echo 'Converting configuration …'."<br />\n";
+		echo 'Converting configuration…'."<br />\n";
 		foreach ($forum_config as $conf_name => $conf_value)
 		{
 			if (convert_to_utf8($conf_value, $old_charset))
@@ -1238,7 +1242,7 @@
 		}
 
 		// Convert categories
-		echo 'Converting categories …'."<br />\n";
+		echo 'Converting categories…'."<br />\n";
 		$query = array(
 			'SELECT'	=> 'id, cat_name',
 			'FROM'		=> 'categories',
@@ -1261,7 +1265,7 @@
 		}
 
 		// Convert forums
-		echo 'Converting forums …'."<br />\n";
+		echo 'Converting forums…'."<br />\n";
 		$query = array(
 			'SELECT'	=> 'id, forum_name, forum_desc, moderators',
 			'FROM'		=> 'forums',
@@ -1295,7 +1299,7 @@
 		}
 
 		// Convert groups
-		echo 'Converting groups …'."<br />\n";
+		echo 'Converting groups…'."<br />\n";
 		$query = array(
 			'SELECT'	=> 'g_id, g_title, g_user_title',
 			'FROM'		=> 'groups',
@@ -1320,7 +1324,7 @@
 		}
 
 		// Convert ranks
-		echo 'Converting ranks …'."<br />\n";
+		echo 'Converting ranks…'."<br />\n";
 		$query = array(
 			'SELECT'	=> 'id, rank',
 			'FROM'		=> 'ranks',
@@ -1343,7 +1347,7 @@
 		}
 
 		// Convert censor words
-		echo 'Converting censor words …'."<br />\n";
+		echo 'Converting censor words…'."<br />\n";
 		$query = array(
 			'SELECT'	=> 'id, search_for, replace_with',
 			'FROM'		=> 'censoring',
@@ -1408,7 +1412,7 @@
 		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
 		while ($cur_item = $forum_db->fetch_assoc($result))
 		{
-			echo 'Converting report '.$cur_item['id'].' …<br />'."\n";
+			echo 'Converting report '.$cur_item['id'].'…<br />'."\n";
 			if (convert_to_utf8($cur_item['message'], $old_charset))
 			{
 				$query = array(
@@ -1477,7 +1481,7 @@
 		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
 		while ($cur_item = $forum_db->fetch_assoc($result))
 		{
-			echo 'Converting search word '.$cur_item['id'].' …<br />'."\n";
+			echo 'Converting search word '.$cur_item['id'].'…<br />'."\n";
 			if (convert_to_utf8($cur_item['word'], $old_charset))
 			{
 				$query = array(
@@ -1535,7 +1539,7 @@
 		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
 		while ($cur_item = $forum_db->fetch_assoc($result))
 		{
-			echo 'Converting user '.$cur_item['id'].' …<br />'."\n";
+			echo 'Converting user '.$cur_item['id'].'…<br />'."\n";
 			if (convert_to_utf8($cur_item['username'], $old_charset) | convert_to_utf8($cur_item['title'], $old_charset) | convert_to_utf8($cur_item['realname'], $old_charset) | convert_to_utf8($cur_item['location'], $old_charset) | convert_to_utf8($cur_item['signature'], $old_charset) | convert_to_utf8($cur_item['admin_note'], $old_charset))
 			{
 				$cur_item['title'] = $cur_item['title'] != '' ? '\''.$forum_db->escape($cur_item['title']).'\'' : 'NULL';
@@ -1610,7 +1614,7 @@
 		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
 		while ($cur_item = $forum_db->fetch_assoc($result))
 		{
-			echo 'Converting topic '.$cur_item['id'].' …<br />'."\n";
+			echo 'Converting topic '.$cur_item['id'].'…<br />'."\n";
 			if (convert_to_utf8($cur_item['poster'], $old_charset) | convert_to_utf8($cur_item['subject'], $old_charset) | convert_to_utf8($cur_item['last_poster'], $old_charset))
 			{
 				$query = array(
@@ -1679,7 +1683,7 @@
 		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
 		while ($cur_item = $forum_db->fetch_assoc($result))
 		{
-			echo 'Converting post '.$cur_item['id'].' …<br />'."\n";
+			echo 'Converting post '.$cur_item['id'].'…<br />'."\n";
 			if (convert_to_utf8($cur_item['poster'], $old_charset) | convert_to_utf8($cur_item['message'], $old_charset) | convert_to_utf8($cur_item['edited_by'], $old_charset))
 			{
 				$cur_item['edited_by'] = $cur_item['edited_by'] != '' ? '\''.$forum_db->escape($cur_item['edited_by']).'\'' : 'NULL';
@@ -1716,43 +1720,43 @@
 		// Do the cumbersome charset conversion of MySQL tables/columns
 		if ($db_type == 'mysql' || $db_type == 'mysqli')
 		{
-			echo 'Converting table '.$forum_db->prefix.'bans …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'bans…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'bans');
-			echo 'Converting table '.$forum_db->prefix.'categories …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'categories…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'categories');
-			echo 'Converting table '.$forum_db->prefix.'censoring …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'censoring…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'censoring');
-			echo 'Converting table '.$forum_db->prefix.'config …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'config…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'config');
-			echo 'Converting table '.$forum_db->prefix.'extension_hooks …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'extension_hooks…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'extension_hooks');
-			echo 'Converting table '.$forum_db->prefix.'extensions …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'extensions…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'extensions');
-			echo 'Converting table '.$forum_db->prefix.'forum_perms …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'forum_perms…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'forum_perms');
-			echo 'Converting table '.$forum_db->prefix.'forums …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'forums…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'forums');
-			echo 'Converting table '.$forum_db->prefix.'groups …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'groups…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'groups');
-			echo 'Converting table '.$forum_db->prefix.'online …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'online…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'online');
-			echo 'Converting table '.$forum_db->prefix.'posts …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'posts…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'posts');
-			echo 'Converting table '.$forum_db->prefix.'ranks …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'ranks…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'ranks');
-			echo 'Converting table '.$forum_db->prefix.'reports …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'reports…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'reports');
-			echo 'Converting table '.$forum_db->prefix.'search_cache …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'search_cache…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'search_cache');
-			echo 'Converting table '.$forum_db->prefix.'search_matches …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'search_matches…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'search_matches');
-			echo 'Converting table '.$forum_db->prefix.'search_words …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'search_words…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'search_words');
-			echo 'Converting table '.$forum_db->prefix.'subscriptions …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'subscriptions…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'subscriptions');
-			echo 'Converting table '.$forum_db->prefix.'topics …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'topics…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'topics');
-			echo 'Converting table '.$forum_db->prefix.'users …<br />'."\n"; flush();
+			echo 'Converting table '.$forum_db->prefix.'users…<br />'."\n"; flush();
 			convert_table_utf8($forum_db->prefix.'users');
 		}
 
@@ -1794,7 +1798,7 @@
 		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
 		while ($cur_item = $forum_db->fetch_assoc($result))
 		{
-			echo 'Preparsing post '.$cur_item['id'].' …<br />'."\n";
+			echo 'Preparsing post '.$cur_item['id'].'…<br />'."\n";
 			$preparse_errors = array();
 
 			$query = array(
@@ -1847,7 +1851,7 @@
 		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
 		while ($cur_item = $forum_db->fetch_assoc($result))
 		{
-			echo 'Preparsing signature '.$cur_item['id'].' …<br />'."\n";
+			echo 'Preparsing signature '.$cur_item['id'].'…<br />'."\n";
 			$preparse_errors = array();
 
 			$query = array(
@@ -1991,10 +1995,13 @@
 	<div class="main-content frm">
 		<div class="ct-box info-box">
 			<p>Your forum database was updated successfully.</p>
-<?php if (isset($new_config) && !$written): ?>			<p>In order to complete the process, you must now update your config.php script. <strong>Copy and paste the text in the text box below into the file called config.php in the root directory of your PunBB installation</strong>. The file already exists, so you must edit/overwrite the contents of the old file. You may then <a href="<?php echo $base_url ?>/index.php">go to the forum index</a> once config.php has been updated.</p>
-<?php else: ?>			<p>You may <a href="<?php echo $base_url ?>/index.php">go to the forum index</a> now.</p>
+<?php if (isset($new_config) && !$written): ?>
+			<p>In order to complete the process, you must now update your config.php script. <strong>Copy and paste the text in the text box below into the file called config.php in the root directory of your PunBB installation</strong>. The file already exists, so you must edit/overwrite the contents of the old file. You may then <a href="<?php echo $base_url ?>/index.php">go to the forum index</a> once config.php has been updated.</p>
+<?php else: ?>
+			<p>You may <a href="<?php echo $base_url ?>/index.php">go to the forum index</a> now.</p>
 <?php endif; ?>		</div>
-<?php if (isset($new_config) && !$written): ?>		<form class="frm-form" action="foo">
+<?php if (isset($new_config) && !$written): ?>
+		<form class="frm-form" action="foo">
 			<fieldset class="frm-group group1">
 				<legend class="group-legend"><span>New config.php contents</span></legend>
 				<div class="txt-set set1">
diff -urN punbb-1.3/admin/extensions.php punbb-1.3.4/admin/extensions.php
--- punbb-1.3/admin/extensions.php	2008-11-10 13:52:46.000000000 +0000
+++ punbb-1.3.4/admin/extensions.php	2009-04-17 12:51:23.000000000 +0000
@@ -4,7 +4,7 @@
  *
  * Allows administrators to control the extensions and hotfixes installed in the site.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -412,6 +412,12 @@
 	{
 		($hook = get_hook('aex_uninstall_comply_form_submitted')) ? eval($hook) : null;
 
+		$ext_info = array(
+			'id'			=> $id,
+			'path'			=> FORUM_ROOT.'extensions/'.$id,
+			'url'			=> $base_url.'/extensions/'.$id
+		);
+
 		$notices = array();
 
 		// Run uninstall code
@@ -983,7 +989,7 @@
 		);
 
 		if ($forum_config['o_check_for_versions'] == 1 && isset($forum_ext_last_versions[$id]) && version_compare($ext['version'], $forum_ext_last_versions[$id]['version'], '<'))
-			$forum_page['ext_actions']['latest_ver'] = '<a href="'.$forum_ext_last_versions[$id]['repo_url'].'/'.$id.'/'.$id.'.zip">'.$lang_admin_ext['Download latest version'].'</a>';
+			$forum_page['ext_actions']['latest_ver'] = '<span><a href="'.$forum_ext_last_versions[$id]['repo_url'].'/'.$id.'/'.$id.'.zip">'.$lang_admin_ext['Download latest version'].'</a></span>';
 
 		($hook = get_hook('aex_section_manage_pre_ext_actions')) ? eval($hook) : null;
 
diff -urN punbb-1.3/admin/forums.php punbb-1.3.4/admin/forums.php
--- punbb-1.3/admin/forums.php	2008-11-07 20:44:35.000000000 +0000
+++ punbb-1.3.4/admin/forums.php	2009-04-17 12:51:23.000000000 +0000
@@ -4,7 +4,7 @@
  *
  * Allows administrators to add, modify, and remove forums.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -177,7 +177,6 @@
 		</form>
 	</div>
 
-</div>
 <?php
 
 		($hook = get_hook('afo_del_forum_end')) ? eval($hook) : null;
@@ -426,7 +425,7 @@
 
 	$forum_page['form_info'] = array();
 	if ($cur_forum['redirect_url'])
-		$forum_page['form_info'][] = '<li><span>'.$lang_admin_forums['Forum perms info 2'].'</span></li>';
+		$forum_page['form_info'][] = '<li><span>'.$lang_admin_forums['Forum perms redirect info'].'</span></li>';
 
 	$forum_page['form_info']['read'] = '<li><span>'.$lang_admin_forums['Forum perms read info'].'</span></li>';
 	$forum_page['form_info']['restore'] = '<li><span>'.$lang_admin_forums['Forum perms restore info'].'</span></li>';
@@ -780,7 +779,7 @@
 					<div class="mf-box">
 <?php ($hook = get_hook('afo_pre_edit_cur_forum_name')) ? eval($hook) : null; ?>
 						<div class="mf-field mf-field1 forum-field">
-							<span class="aslabel">Forum name:</span>
+							<span class="aslabel"><?php echo $lang_admin_forums['Forum name'] ?></span>
 							<span class="fld-input"><?php echo forum_htmlencode($cur_forum['forum_name']) ?></span>
 						</div>
 <?php ($hook = get_hook('afo_pre_edit_cur_forum_position')) ? eval($hook) : null; ?>
diff -urN punbb-1.3/admin/groups.php punbb-1.3.4/admin/groups.php
--- punbb-1.3/admin/groups.php	2008-10-30 11:00:54.000000000 +0000
+++ punbb-1.3.4/admin/groups.php	2009-04-17 12:51:23.000000000 +0000
@@ -4,7 +4,7 @@
  *
  * Allows administrators to control group permissions.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -180,8 +180,8 @@
 								<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="mod_ban_users" value="1"<?php if ($group['g_mod_ban_users'] == '1') echo ' checked="checked"' ?> /></span>
 								<label for="fld<?php echo $forum_page['fld_count'] ?>"><?php echo $lang_admin_groups['Allow mod bans label'] ?></label>
 							</div>
-						</div>
 <?php ($hook = get_hook('agr_add_edit_group_pre_mod_permissions_fieldset_end')) ? eval($hook) : null; ?>
+						</div>
 					</fieldset>
 <?php ($hook = get_hook('agr_add_edit_group_mod_permissions_fieldset_end')) ? eval($hook) : null; endif; endif; ?>
 					<fieldset class="mf-set set<?php echo ++$forum_page['item_count'] ?>">
@@ -242,9 +242,8 @@
 								<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="send_email" value="1"<?php if ($group['g_send_email'] == '1') echo ' checked="checked"' ?> /></span>
 								<label for="fld<?php echo $forum_page['fld_count'] ?>"><?php echo $lang_admin_groups['Allow send email label'] ?></label>
 							</div>
-<?php endif; ?>
+<?php endif; ($hook = get_hook('agr_add_edit_group_pre_user_permissions_fieldset_end')) ? eval($hook) : null; ?>
 						</div>
-<?php ($hook = get_hook('agr_add_edit_group_pre_user_permissions_fieldset_end')) ? eval($hook) : null; ?>
 					</fieldset>
 <?php ($hook = get_hook('agr_add_edit_group_user_permissions_fieldset_end')) ? eval($hook) : null; ?>
 				</fieldset>
diff -urN punbb-1.3/admin/index.php punbb-1.3.4/admin/index.php
--- punbb-1.3/admin/index.php	2008-11-07 20:34:47.000000000 +0000
+++ punbb-1.3.4/admin/index.php	2009-04-17 12:51:23.000000000 +0000
@@ -4,7 +4,7 @@
  *
  * Gives an overview of some statistics to administrators and moderators.
  *
- * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
+ * @copyright (C) 2008-2009 PunBB, partially based on code (C) 2008-2009 FluxBB.org
  * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
  * @package PunBB
  */
@@ -147,10 +147,11 @@
 // Setup breadcrumbs
 $forum_page['crumbs'] = array(
 	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
-	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
-	array($lang_admin_common['Start'], forum_link($forum_url['admin_index'])),
-	array($lang_admin_common['Information'], forum_link($forum_url['admin_index']))
+	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index']))
 );
+if ($forum_user['g_id'] == FORUM_ADMIN)
+	$forum_page['crumbs'][] = array($lang_admin_common['Start'], forum_link($forum_url['admin_index']));
+$forum_page['crumbs'][] = array($lang_admin_common['Information'], forum_link($forum_url['admin_index']));
 
 ($hook = get_hook('ain_pre_header_load')) ? eval($hook) : null;
 
@@ -185,7 +186,7 @@
 					<h3 class="ct-legend hn"><span><?php echo $lang_admin_index['PunBB version'] ?></span></h3>
 					<ul class="data-list">
 						<li><span>PunBB <?php echo $forum_config['o_cur_version'] ?></span></li>
-						<li><span>&copy; Copyright 2008 <a href="http://punbb.informer.com/">PunBB</a></span></li>
+						<li><span><?php echo $lang_admin_index['Copyright message'] ?></span></li>
 <?php if (isset($punbb_updates)): ?>
 						<li><span><?php echo $punbb_updates ?></span></li>
 <?php endif; ?>
@@ -217,7 +218,7 @@
 					<ul class="data-list">
 						<li><span><?php echo implode(' ', $forum_db->get_version()) ?></span></li>
 <?php if (isset($total_records) && isset($total_size)): ?>
-							<li><span><?php echo $lang_admin_index['Rows'] ?>: <?php echo forum_number_format($total_records) ?></span></li>
+						<li><span><?php echo $lang_admin_index['Rows'] ?>: <?php echo forum_number_format($total_records) ?></span></li>
 						<li><span><?php echo $lang_admin_index['Size'] ?>: <?php echo $total_size ?></span></li>
 <?php endif; ?>
 					</ul>
